package circledisplaywrapper;

import main.java.com.philjay.circledisplay.CircleDisplay;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("CircleDisplay")
public class circleDisplayWrapper extends ViewWrapper<CircleDisplay> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private CircleDisplay cv;
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new CircleDisplay(ba.context);
                this.setObject(cv);
//                setEventName(this.eventName);
//                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PopSeekBarView.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }


//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}















    /**
     * shows the given value in the circle view
     * 
     * @param toShow
     * @param total
     * @param animated
     */
    public void showValue(float toShow, float total, boolean animated) {
       cv.showValue(toShow, total, animated);
       cv.invalidate();
    }

    /**
     * Sets the unit that is displayed next to the value in the center of the
     * view. Default "%". Could be "" or "$" or left blank or whatever it is
     * you display.
     * 
     * @param unit
     */
    public void setUnit(String unit) {
        cv.setUnit(unit);
        cv.invalidate();
    }

    /**
     * Returns the currently displayed value from the view. Depending on the
     * used method to show the value, this value can be percent or actual value.
     * 
     * @return
     */
    public float getValue() {
        return cv.getValue();
    }

    public void startAnim() {
        cv.startAnim();
        cv.invalidate();
    }

    /**
     * set the duration of the drawing animation in milliseconds
     * 
     * @param durationmillis
     */
    public void setAnimDuration(int durationmillis) {
        cv.setAnimDuration(durationmillis);
        cv.invalidate();
    }

    /**
     * returns the diameter of the drawn circle/arc
     * 
     * @return
     */
    public float getDiameter() {
        return cv.getDiameter();
    }

    /**
     * returns the radius of the drawn circle
     * 
     * @return
     */
    public float getRadius() {
        return cv.getRadius();
    }

    /**
     * set the starting angle for the view
     * 
     * @param angle
     */
    public void setStartAngle(float angle) {
        cv.setStartAngle(angle);
        cv.invalidate();
    }

    /**
     * returns the current animation status of the view
     * 
     * @return
     */
    public float getPhase() {
        return cv.getPhase();
    }


    /**
     * set this to true to draw the inner circle, default: true
     * 
     * @param enabled
     */
    public void setDrawInnerCircle(boolean enabled) {
        cv.setDrawInnerCircle(enabled);
        cv.invalidate();
    }

    /**
     * returns true if drawing the inner circle is enabled, false if not
     * 
     * @return
     */
    public boolean isDrawInnerCircleEnabled() {
        return cv.isDrawInnerCircleEnabled();
    }

    /**
     * set the drawing of the center text to be enabled or not
     * 
     * @param enabled
     */
    public void setDrawText(boolean enabled) {
        cv.setDrawText(enabled);
        cv.invalidate();
    }

    /**
     * returns true if drawing the text in the center is enabled
     * 
     * @return
     */
    public boolean isDrawTextEnabled() {
        return cv.isDrawTextEnabled();
    }

    /**
     * set the color of the arc
     * 
     * @param color
     */
    public void setColor(int color) {
        cv.setColor(color);
        cv.invalidate();
    }

    /**
     * set the size of the center text in dp
     * 
     * @param size
     */
    public void setTextSize(float size) {
        cv.setTextSize(size);
        cv.invalidate();
    }

    /**
     * set the thickness of the value bar, default 50%
     * 
     * @param percentFromTotalWidth
     */
    public void setValueWidthPercent(float percentFromTotalWidth) {
        cv.setValueWidthPercent(percentFromTotalWidth);
        cv.invalidate();
    }

    /**
     * Set an array of custom texts to be drawn instead of the value in the
     * center of the CircleDisplay. If set to null, the custom text will be
     * reset and the value will be drawn. Make sure the length of the array corresponds with the maximum number of steps (set with setStepSize(float stepsize).
     * 
     * @param custom
     */
    public void setCustomText(String[] custom) {
        cv.setCustomText(custom);
        cv.invalidate();
    }

    /**
     * sets the number of digits used to format values
     * 
     * @param digits
     */
    public void setFormatDigits(int digits) {
       cv.setFormatDigits(digits);
       cv.invalidate();
    }

    /**
     * set the aplha value to be used for the remainder of the arc, default 80
     * (use value between 0 and 255)
     * 
     * @param alpha
     */
    public void setDimAlpha(int alpha) {
        cv.setDimAlpha(alpha);
        cv.invalidate();
    }

    /** paint used for drawing the text */
//    public static final int PAINT_TEXT = 1;

    /** paint representing the value bar */
//    public static final int PAINT_ARC = 2;

    /** paint representing the inner (by default white) area */
//    public static final int PAINT_INNER = 3;


    /**
     * Sets the stepsize (minimum selection interval) of the circle display,
     * default 1f. It is recommended to make this value not higher than 1/5 of
     * the maximum selectable value, and not lower than 1/200 of the maximum
     * selectable value. For a maximum value of 100 for example, a stepsize
     * between 0.5 and 20 is recommended.
     * 
     * @param stepsize
     */
//    public void setStepSize(float stepsize) {
//        cv.setStepSize(stepsize);
//        cv.invalidate();
//    }

    /**
     * returns the current stepsize of the display, default 1f
     * 
     * @return
     */
//    public float getStepSize() {
//        return cv.getStepSize();
//    }


    /**
     * Enable touch gestures on the circle-display. If enabled, selecting values
     * onTouch() is possible. Set a SelectionListener to retrieve selected
     * values. Do not forget to set a value before selecting values. By default
     * the maxvalue is 0f and therefore nothing can be selected.
     * 
     * @param enabled
     */
//    public void setTouchEnabled(boolean enabled) {
//        cv.setTouchEnabled(enabled);
//    }

    /**
     * returns true if touch-gestures are enabled, false if not
     * 
     * @return
     */
//    public boolean isTouchEnabled() {
//        return cv.isTouchEnabled();
//    }

    public void setInnerCircleColor (int innercirclecolor){
       cv.setInnerCircleColor(innercirclecolor);
       cv.invalidate();
    }

    public void setTextColor (int textcolor){
       cv.setTextColor(textcolor);
       cv.invalidate();
    }

}
